-- MySQL Script generated by MySQL Workbench
-- Sun 26 May 2019 02:41:33 PM WIB
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- -----------------------------------------------------
-- Schema simontok
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema simontok
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `simontok` DEFAULT CHARACTER SET utf8 ;
USE `simontok` ;

-- -----------------------------------------------------
-- Table `simontok`.`appVersion`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`appVersion` (
  `appName` VARCHAR(20) NOT NULL,
  `lastVersion` TINYINT(2) NOT NULL,
  PRIMARY KEY (`appName`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `simontok`.`counterDB`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`counterDB` (
  `tableName` VARCHAR(64) NOT NULL,
  `initial` VARCHAR(5) NOT NULL,
  `lastUpdate` DATE NULL DEFAULT NULL,
  `nextID` INT(4) NULL DEFAULT '1',
  `resetID` INT(1) NULL DEFAULT NULL,
  `notes` VARCHAR(20) NULL DEFAULT NULL,
  PRIMARY KEY (`tableName`),
  UNIQUE INDEX `initial` (`initial` ASC))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8
COMMENT = '0 tanpa reset.1 perhari ,2 perminggu 3 perbulan 4 pertahun';


-- -----------------------------------------------------
-- Table `simontok`.`user`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`user` (
  `userID` VARCHAR(20) NOT NULL,
  `wilayahPenempatan` VARCHAR(7) NOT NULL COMMENT 'kode penempatan wilayah / unit/ area',
  `username` VARCHAR(20) NOT NULL,
  `realName` VARCHAR(100) NOT NULL,
  `lastLoginIP` VARCHAR(36) NULL DEFAULT NULL,
  `password` VARCHAR(32) NOT NULL,
  `mail` VARCHAR(128) NULL DEFAULT NULL,
  `phone` VARCHAR(32) NULL DEFAULT NULL,
  `messenger` VARCHAR(128) NULL DEFAULT NULL,
  `bod` DATE NULL DEFAULT NULL,
  `join` DATE NULL DEFAULT NULL,
  `lastLogin` DATETIME NULL DEFAULT NULL,
  `lastSession` VARCHAR(32) NULL DEFAULT NULL,
  `firebaseToken` VARCHAR(255) NULL,
  `loginToken` VARCHAR(255) NULL,
  `language` VARCHAR(2) NULL DEFAULT NULL,
  `gender` ENUM('m', 'f') NULL DEFAULT 'm',
  `avatar` VARCHAR(200) NULL DEFAULT NULL,
  `notes` TEXT NULL DEFAULT NULL,
  `isDC` TINYINT(1) NULL DEFAULT '1' COMMENT 'apakah join domain.0 tidak;1 join domain',
  `active` TINYINT(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`userID`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8
COMMENT = 'tabel user yang ada didalam system'
ROW_FORMAT = DYNAMIC;


-- -----------------------------------------------------
-- Table `simontok`.`deviceUserRegister`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`deviceUserRegister` (
  `durID` INT(6) NOT NULL AUTO_INCREMENT,
  `userID` VARCHAR(20) NOT NULL,
  `appID` VARCHAR(45) NULL ,  
  `appVersion` TINYINT(2) NULL ,
  `firebaseToken` VARCHAR(255) NOT NULL,
  `deviceModel` VARCHAR(63) NOT NULL,
  `deviceMerk` VARCHAR(16) NOT NULL,
  `deviceSDK` TINYINT(2) NOT NULL,
  `androidVersion` VARCHAR(45) NULL,
  `androidID` VARCHAR(45) NULL,
  `deviceUUID` VARCHAR(45) NULL,
  `language` VARCHAR(45) NULL,
  `country` VARCHAR(45) NULL,
  `carrier` VARCHAR(45) NULL,
  `carrierID` VARCHAR(45) NULL,
  `screenSize` DECIMAL(4,2) NULL,
  `screenResolution` VARCHAR(45) NULL,
  `screenDPI` DECIMAL(3,2) NULL,
  `dateRegister` DATETIME NOT NULL,
  `registerStatus` TINYINT(1) NOT NULL DEFAULT '1' COMMENT '0 baru masuk; 1 aktif',
  PRIMARY KEY (`durID`),
  INDEX `fk_deviceUserRegister_userID_user_userID_idx` (`userID` ASC),
  CONSTRAINT `fk_deviceUserRegister_userID_user_userID`
    FOREIGN KEY (`userID`)
    REFERENCES `simontok`.`user` (`userID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
AUTO_INCREMENT = 52
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `simontok`.`firewall`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`firewall` (
  `firewallID` INT(4) NOT NULL AUTO_INCREMENT,
  `userID` VARCHAR(20) NOT NULL,
  `clientAddress` VARCHAR(20) NOT NULL,
  `dateCreate` DATE NOT NULL,
  PRIMARY KEY (`firewallID`))
ENGINE = InnoDB
AUTO_INCREMENT = 5
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `simontok`.`group`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`group` (
  `groupID` VARCHAR(20) NOT NULL DEFAULT '',
  `name` VARCHAR(25) NOT NULL,
  `active` TINYINT(1) NOT NULL DEFAULT '1',
  `notes` TEXT NOT NULL,
  PRIMARY KEY (`groupID`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8
COMMENT = 'group id untuk level akses.';


-- -----------------------------------------------------
-- Table `simontok`.`helpdeskCounter`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`helpdeskCounter` (
  `unitID` VARCHAR(7) NOT NULL,
  `lastHelpdesk` TINYINT(2) NOT NULL,
  PRIMARY KEY (`unitID`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `simontok`.`helpdeskHandle`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`helpdeskHandle` (
  `hhID` INT(3) NOT NULL AUTO_INCREMENT,
  `helpdeskID` VARCHAR(20) NOT NULL,
  `unitHandle` VARCHAR(7) NOT NULL,
  PRIMARY KEY (`hhID`),
  INDEX `fk_fk_hh_helpdeskid_user_userid_1` (`helpdeskID` ASC),
  CONSTRAINT `fk_fk_hh_helpdeskid_user_userid_1`
    FOREIGN KEY (`helpdeskID`)
    REFERENCES `simontok`.`user` (`userID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
AUTO_INCREMENT = 8
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `simontok`.`komputer`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`komputer` (
  `komputerID` VARCHAR(20) NOT NULL,
  `komputerUser` VARCHAR(45) NULL DEFAULT NULL,
  `helpdeskGroupHandle` VARCHAR(20) NOT NULL,
  `komputerIdentifikasi` VARCHAR(128) NULL DEFAULT NULL,
  `komputerPengadaan` varchar(45) DEFAULT NULL,
  `komputerTipe` VARCHAR(32) NULL DEFAULT NULL,
  `komputerPosisi` VARCHAR(32) NULL DEFAULT NULL,
  `komputerIPUtama` VARCHAR(32) NULL DEFAULT NULL,
  `komputerAuditEntry` DATETIME NOT NULL,
  `komputerTokenServer` VARCHAR(45) NULL,
  `komputerStatus` TINYINT(1) NULL DEFAULT '0' COMMENT '0 baik; 1 perbaikan;2 rusak;3 pengajuan dihapus;9 dihapus',
  PRIMARY KEY (`komputerID`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `simontok`.`komputerHistorisPemakaian`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`komputerHistorisPemakaian` (
  `komputerHistorisID` INT(6) NOT NULL AUTO_INCREMENT,
  `komputerID` VARCHAR(20) NOT NULL,
  `komputerUserID` VARCHAR(20) NOT NULL,
  `komputerHistorisTgl` DATE NOT NULL,
  `komputerHistorisKet` VARCHAR(32) NULL DEFAULT NULL,
  `komputerHistorisStatus` VARCHAR(1) NOT NULL DEFAULT '1' COMMENT '1:aktif;0 :didelete',
  PRIMARY KEY (`komputerHistorisID`))
ENGINE = InnoDB
AUTO_INCREMENT = 16
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `simontok`.`komputerItem`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`komputerItem` (
  `komputerItemID` VARCHAR(20) NOT NULL,
  `komputerItemNama` VARCHAR(45) NULL DEFAULT NULL,
  PRIMARY KEY (`komputerItemID`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `simontok`.`komputerSpek`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`komputerSpek` (
  `komputerSpekID` INT(5) NOT NULL AUTO_INCREMENT,
  `komputerID` VARCHAR(20) NULL DEFAULT NULL,
  `komputerItemID` VARCHAR(20) NULL DEFAULT NULL,
  `komputerSpekKapasitas` INT(24) UNSIGNED NULL DEFAULT NULL,
  `komputerSpekMerk` VARCHAR(64) NULL DEFAULT NULL,
  `komputerSpekSerialNumber` VARCHAR(128) NULL DEFAULT NULL,
  `komputerSpekKeterangan` VARCHAR(128) NULL DEFAULT NULL,
  `komputerTokenServer` VARCHAR(45) NULL,
  `komputerSpekDate` DATE NULL,
  `komputerSpekStatus` TINYINT(1) NOT NULL DEFAULT '1' COMMENT '1 aktif;0 rencana dihapus;9 sudah dihapus permanen diapprove spv ti',
  PRIMARY KEY (`komputerSpekID`),
  INDEX `fk_komputerSpek_komputer` (`komputerID` ASC),
  INDEX `fk_komputerSpek_komputerItem` (`komputerItemID` ASC),
  INDEX `idx_komputerSpek` (`komputerSpekKapasitas` ASC, `komputerSpekMerk` ASC),
  CONSTRAINT `fk_komputerSpek_komputerID_komputer_komputerID`
    FOREIGN KEY (`komputerID`)
    REFERENCES `simontok`.`komputer` (`komputerID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
AUTO_INCREMENT = 37
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `simontok`.`log`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`log` (
  `logID` VARCHAR(20) NOT NULL,
  `logUserID` VARCHAR(20) NULL DEFAULT NULL,
  `logUserAgent` VARCHAR(200) NULL DEFAULT NULL,
  `logTime` DATETIME NULL DEFAULT NULL,
  `logClientIP` VARCHAR(15) NULL DEFAULT NULL,
  `logClientURL` VARCHAR(128) NULL DEFAULT NULL,
  `logModulID` VARCHAR(8) NOT NULL,
  `logDetail` VARCHAR(200) NOT NULL,
  PRIMARY KEY (`logID`),
  INDEX `fk_log_logUserID_user_userID` (`logUserID` ASC))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8
COMMENT = 'table keterangan histori / log';


-- -----------------------------------------------------
-- Table `simontok`.`menu`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`menu` (
  `id` SMALLINT(3) NOT NULL AUTO_INCREMENT,
  `parentID` SMALLINT(3) NULL DEFAULT '0' COMMENT 'sebangai induk dari menu',
  `icon` VARCHAR(256) NOT NULL,
  `title` VARCHAR(100) NOT NULL DEFAULT '',
  `url` VARCHAR(100) NOT NULL DEFAULT '',
  `menuOrder` TINYINT(3) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'memilah2 mana yang diletakan diatas / bawah',
  `keterangan` VARCHAR(20) NULL DEFAULT NULL,
  `status` TINYINT(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  INDEX `fk_menu_menu_parentID` (`parentID` ASC))
ENGINE = InnoDB
AUTO_INCREMENT = 7
DEFAULT CHARACTER SET = utf8
COMMENT = 'menu links untuk URL.group id 0 boleh diakses siapa saja'
ROW_FORMAT = DYNAMIC;


-- -----------------------------------------------------
-- Table `simontok`.`notification`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`notification` (
  `notifID` INT(5) NOT NULL AUTO_INCREMENT,
  `notifTitle` VARCHAR(45) NULL DEFAULT NULL,
  `notifMessage` TEXT NULL DEFAULT NULL,
  `notifLink` VARCHAR(160) NULL DEFAULT NULL,
  `notifUserTo` VARCHAR(20) NOT NULL,
  `notifToFirebaseID` VARCHAR(255) NULL,
  `notifUserFrom` VARCHAR(20) NULL DEFAULT NULL,
  `notifDateCreate` DATETIME NOT NULL,
  `notifLogo` VARCHAR(100) NOT NULL,
  `notifStatus` TINYINT(1) NOT NULL DEFAULT 0 COMMENT '0:belum dibaca.1:terkirim;2:diterima;3:terbaca;9 dihapus',
  PRIMARY KEY (`notifID`),
  INDEX `fk_notification_notifUserTo_user_userID_idx` (`notifUserTo` ASC),
  CONSTRAINT `fk_notification_notifUserTo_user_userID`
    FOREIGN KEY (`notifUserTo`)
    REFERENCES `simontok`.`user` (`userID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
AUTO_INCREMENT = 1257
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `simontok`.`pageRegistered`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`pageRegistered` (
  `pageID` VARCHAR(6) NOT NULL,
  `filename` VARCHAR(255) NOT NULL,
  `notes` VARCHAR(255) NOT NULL,
  PRIMARY KEY (`pageID`),
  INDEX `idx_pageID_pageID` (`pageID` ASC))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8
COMMENT = 'halaman yang hanya bisa diakses oleh user yang berhak'
ROW_FORMAT = DYNAMIC;


-- -----------------------------------------------------
-- Table `simontok`.`ticket`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`ticket` (
  `ticketID` INT(6) NOT NULL AUTO_INCREMENT,
  `ticketNumber` VARCHAR(60) NOT NULL,
  `ticketRequestID` VARCHAR(20) NULL DEFAULT NULL,
  `ticketKomputerID` VARCHAR(20) NULL DEFAULT NULL,
  `ticketUserApproveDate` DATE NULL DEFAULT NULL COMMENT 'user atasan yang mengappove jika pending',
  `ticketRequestDate` DATETIME NULL DEFAULT NULL,
  `ticketProblemStatus` TINYINT(1) NOT NULL DEFAULT '0' COMMENT '0:pengerjaan;1:menunggu persetujuan;2menunggu material',
  `ticketProblemDesc` TEXT NULL DEFAULT NULL,
  `ticketHelpdeskHandle` VARCHAR(20) NULL DEFAULT NULL,
  `ticketSolveCategory` VARCHAR(30) NULL DEFAULT NULL COMMENT '0:aplikasi;1:hardware;2:jaringan;3:virus;4:lainlain',
  `ticketSolvePriority` VARCHAR(2) NULL DEFAULT NULL COMMENT '0:tinggi;1:sedang;2:rendah',
  `ticketSolveDateStart` DATETIME NULL DEFAULT NULL COMMENT 'tanggal mulai dianalisa',
  `ticketSolveDateFinish` DATETIME NULL DEFAULT NULL,
  `ticketSolveDesc` TINYTEXT NULL DEFAULT NULL,
  `ticketUserApproveID` VARCHAR(20) NULL DEFAULT NULL COMMENT 'user atasan . opsional diperlukan jika memerlukan  persetujuan',
  `ticketStatusDesc` TINYTEXT NULL DEFAULT NULL COMMENT 'jika memerlukan persetujuan seperti menuggu material',
  `ticketUserDeleteID` VARCHAR(20) NULL COMMENT 'jika ada yang menghapus tiket',
  `ticketStatus` TINYINT(1) NULL DEFAULT '0' COMMENT '0:baru masuk;1 sedang dikerjakan;2 menunggu persetujuan;3 menunggu material;8finish;9:dihapus noc',
  PRIMARY KEY (`ticketID`),
  INDEX `fk_ticket_request_user_userID_idx` (`ticketRequestID` ASC),
  CONSTRAINT `fk_ticket_request_user_userID`
    FOREIGN KEY (`ticketRequestID`)
    REFERENCES `simontok`.`user` (`userID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
AUTO_INCREMENT = 26
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `simontok`.`tokenHandle`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`tokenHandle` (
  `tokenID` VARCHAR(40) NOT NULL,
  `createUser` VARCHAR(20) NOT NULL,
  `createDate` DATETIME NOT NULL,
  `expiredDate` DATETIME NOT NULL,
  `status` TINYINT(1) NOT NULL DEFAULT '0' COMMENT '0 belum dipakai; 1sudah dipakai',
  PRIMARY KEY (`tokenID`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `simontok`.`userAccessLevel`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`userAccessLevel` (
  `id` INT(4) NOT NULL AUTO_INCREMENT,
  `groupID` VARCHAR(20) NOT NULL,
  `pageID` VARCHAR(6) NOT NULL,
  `active` TINYINT(1) NOT NULL DEFAULT '1',
  `notes` VARCHAR(32) NULL DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE INDEX `unq_groupID_pageID` (`groupID` ASC, `pageID` ASC),
  INDEX `idx_groupID_pageID` (`groupID` ASC, `pageID` ASC),
  INDEX `fk_userAccessLevel_group_groupID` (`groupID` ASC),
  INDEX `fk_userAccessLevel_pageRegisterd_pageID` (`pageID` ASC),
  INDEX `fk_userAccessLevel_pageID_pageRegistered_pageID_idx` (`pageID` ASC),
  INDEX `fk_userAccessLevel_pageID_pageID_group_groupID_idx` (`groupID` ASC),
  CONSTRAINT `fk_userAccessLevel_pageID_pageID_group_groupID`
    FOREIGN KEY (`groupID`)
    REFERENCES `simontok`.`group` (`groupID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_userAccessLevel_pageID_pageRegistered_pageID`
    FOREIGN KEY (`pageID`)
    REFERENCES `simontok`.`pageRegistered` (`pageID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
AUTO_INCREMENT = 14
DEFAULT CHARACTER SET = utf8
COMMENT = 'halaman yang hanya bisa diakses oleh user yang berhak'
ROW_FORMAT = DYNAMIC;


-- -----------------------------------------------------
-- Table `simontok`.`userGroup`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`userGroup` (
  `userGroupID` INT(6) NOT NULL AUTO_INCREMENT,
  `userID` VARCHAR(20) NOT NULL,
  `groupID` VARCHAR(20) NOT NULL,
  `status` TINYINT(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`userGroupID`),
  UNIQUE INDEX `unq_userID_groupID` (`userID` ASC, `groupID` ASC),
  INDEX `idx_userID_groupID` (`groupID` ASC, `userID` ASC),
  INDEX `fk_userGroup_user_userID` (`userID` ASC),
  INDEX `fk_group_user_groupID` (`groupID` ASC),
  INDEX `fk_userGroup_userID_user_userID_idx` (`userID` ASC),
  INDEX `fk_userGroup_groupID_group_groupID_idx` (`groupID` ASC),
  CONSTRAINT `fk_userGroup_groupID_group_groupID`
    FOREIGN KEY (`groupID`)
    REFERENCES `simontok`.`group` (`groupID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_userGroup_userID_user_userID`
    FOREIGN KEY (`userID`)
    REFERENCES `simontok`.`user` (`userID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
AUTO_INCREMENT = 30
DEFAULT CHARACTER SET = utf8
ROW_FORMAT = COMPACT;


-- -----------------------------------------------------
-- Table `simontok`.`userMenu`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`userMenu` (
  `userMenuID` SMALLINT(3) NOT NULL AUTO_INCREMENT,
  `menuID` SMALLINT(3) NOT NULL,
  `groupID` VARCHAR(20) NULL DEFAULT NULL,
  `status` TINYINT(1) NULL DEFAULT '1',
  PRIMARY KEY (`userMenuID`),
  UNIQUE INDEX `unq_menuID_groupID` (`menuID` ASC, `groupID` ASC),
  INDEX `idx_menuID_groupID` (`menuID` ASC, `groupID` ASC),
  INDEX `fk_userMenu_menu_menuID` (`menuID` ASC),
  INDEX `fk_userMenu_group1` (`groupID` ASC),
  INDEX `fk_userMenu_menuID_menu_id_idx` (`menuID` ASC),
  INDEX `fk_userMenu_groupID_group_groupID_idx` (`groupID` ASC),
  CONSTRAINT `fk_userMenu_groupID_group_groupID`
    FOREIGN KEY (`groupID`)
    REFERENCES `simontok`.`group` (`groupID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_userMenu_menuID_menu_id`
    FOREIGN KEY (`menuID`)
    REFERENCES `simontok`.`menu` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
AUTO_INCREMENT = 12
DEFAULT CHARACTER SET = utf8
ROW_FORMAT = DYNAMIC;


-- -----------------------------------------------------
-- Table `simontok`.`wilayahKerja`
-- -----------------------------------------------------
CREATE TABLE `wilayahKerja` (
  `idWilayah` varchar(10) NOT NULL,
  `namaWilayah` varchar(60) NOT NULL,
  `parentWilayah` varchar(10) DEFAULT NULL,
  `kontakWilayah` varchar(45) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


-- -----------------------------------------------------
-- Table `simontok`.`tempKomputerSpekUpgrade`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`tempKomputerSpekUpgrade` (
  `komputerSpekID` INT(5) NOT NULL AUTO_INCREMENT,
  `komputerID` VARCHAR(20) NULL DEFAULT NULL,
  `komputerItemID` VARCHAR(20) NULL DEFAULT NULL,
  `komputerSpekKapasitas` INT(24) UNSIGNED NULL DEFAULT NULL,
  `komputerSpekMerk` VARCHAR(64) NULL DEFAULT NULL,
  `komputerSpekSerialNumber` VARCHAR(128) NULL DEFAULT NULL,
  `komputerSpekKeterangan` VARCHAR(128) NULL DEFAULT NULL,
  `komputerTokenServer` VARCHAR(45) NULL,
  `komputerSpekDate` DATE NULL,
  `komputerSpekStatus` TINYINT(1) NOT NULL DEFAULT '1' COMMENT '1 aktif;0 nonaktif',
  PRIMARY KEY (`komputerSpekID`),
  INDEX `fk_komputerSpek_komputer` (`komputerID` ASC),
  INDEX `fk_komputerSpek_komputerItem` (`komputerItemID` ASC),
  INDEX `idx_komputerSpek` (`komputerSpekKapasitas` ASC, `komputerSpekMerk` ASC),
  CONSTRAINT `fk_komputerSpek_komputerID_komputer_komputerID0`
    FOREIGN KEY (`komputerID`)
    REFERENCES `simontok`.`komputer` (`komputerID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
AUTO_INCREMENT = 37
DEFAULT CHARACTER SET = utf8
COMMENT = 'digunakan jika ada komponen item komputer yang ditambah';

USE `simontok` ;

-- -----------------------------------------------------
-- Placeholder table for view `simontok`.`vUserMenu`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`vUserMenu` (`userID` INT, `realname` INT, `groupID` INT, `name` INT, `status` INT, `id` INT, `parentID` INT, `icon` INT, `title` INT, `url` INT, `menuOrder` INT, `keterangan` INT);

-- -----------------------------------------------------
-- Placeholder table for view `simontok`.`vUserAccessLevel`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `simontok`.`vUserAccessLevel` (`userID` INT, `realname` INT, `groupID` INT, `name` INT, `pageID` INT, `filename` INT, `active` INT);

-- -----------------------------------------------------
-- function getNextID
-- -----------------------------------------------------

DELIMITER $$
USE `simontok`$$
CREATE  FUNCTION `getNextID`(_tableName varchar(50),_initialID bool) RETURNS varchar(40) CHARSET utf8
    COMMENT '4 untuk pertahun'
BEGIN

    SET @strIDLength = 16;
    SET @result = '';
    SET @i = 1;
    SET @strDate = '';
    SET @debug = 0;
    SET @strDebug = '';

    SELECT nextID,initial,lastUpdate,resetID INTO @nextID,@initial,@lastUpdate,@resetID FROM counterDB WHERE tableName = _tableName;
    SET @i = @nextID;
    CASE @resetID

        WHEN  1 THEN
            SET @strDate = CONCAT(YEAR(CURDATE()),LPAD(MONTH(CURDATE()),2,'0'),LPAD(DATE_FORMAT(now(),'%d'),2,'0'));

        WHEN  2 THEN
            SET @strDate = CONCAT( YEAR( CURDATE() ), WEEKOFYEAR( CURDATE() ) );

        WHEN  3 THEN
            SET @strDate = CONCAT( YEAR( CURDATE() ),MONTH( CURDATE() ) );

        WHEN  4 THEN
            SET @strDate = YEAR(CURDATE());

        ELSE
            SET @strDate = '';
    END CASE;



    IF(@lastUpdate < CURDATE()) THEN

        CASE @resetID

            WHEN  0 THEN
                SET @i = @nextID;


            WHEN  1 THEN
                SET @i = 1;
                SET @strDate = CONCAT(YEAR(CURDATE()),LPAD(MONTH(CURDATE()),2,'0'),LPAD(DATE_FORMAT(now(),'%d'),2,'0'));
                IF ( @debug = 1 ) THEN
                    SET @strDebug = 'perhari';
                END IF;

            WHEN  2 THEN
                IF ( WEEKOFYEAR(@lastUpdate)!= WEEKOFYEAR(CURDATE())  ) THEN
                    SET @i = 1;
                END IF;
                IF ( @debug = 1 ) THEN
                    SET @strDebug = 'perminggu';
                END IF;

            WHEN  3 THEN
                IF (MONTH(@lastUpdate) != MONTH(CURDATE()) )  THEN
                    SET @i = 1;
                END IF;
                IF ( @debug = 1 ) THEN
                    SET @strDebug = 'perbulan';
                END IF;

            WHEN  4 THEN
                IF ( YEAR(@lastUpdate) != YEAR(CURDATE())  ) THEN
                    SET @i = 1;
                END IF;
                IF ( @debug = 1 ) THEN
                    SET @strDebug = 'pertahun';
                END IF;
            ELSE

                SET @result = '';

        END CASE;
    ELSE

        SET @i = @nextID;
        IF ( @debug = 1 ) THEN
            SET @strDebug = 'tanpa waktu';
        END IF;
    END IF;




    UPDATE counterDB
    SET nextID = @i + 1,lastUpdate = CURDATE()
    WHERE  counterDB.tableName = _tableName;

    IF (_initialID)  THEN
        SET @result = CONCAT(@initial,@strDate,LPAD(@i,16-LENGTH(CONCAT(@initial,@strDate)),'0'));

    ELSE
        SET @result = @i;
    END IF;

    IF ( @debug = 1 ) THEN
    	RETURN concat(@result,'|',@strDebug);
    ELSE
	RETURN @result;
    END IF;
END$$

DELIMITER ;

-- -----------------------------------------------------
-- View `simontok`.`vUserMenu`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `simontok`.`vUserMenu`;
USE `simontok`;
CREATE 
 OR REPLACE VIEW `vUserMenu` AS
    SELECT 
        `usr`.`userID` AS `userID`,
        `usr`.`realName` AS `realname`,
        `grp`.`groupID` AS `groupID`,
        `grp`.`name` AS `name`,
        `mnu`.`status` AS `status`,
        `mnu`.`id` AS `id`,
        `mnu`.`parentID` AS `parentID`,
        `mnu`.`icon` AS `icon`,
        `mnu`.`title` AS `title`,
        `mnu`.`url` AS `url`,
        `mnu`.`menuOrder` AS `menuOrder`,
        `mnu`.`keterangan` AS `keterangan`
    FROM
        ((((`userMenu` `usm`
        LEFT JOIN `menu` `mnu` ON ((`mnu`.`id` = `usm`.`menuID`)))
        LEFT JOIN `group` `grp` ON ((`grp`.`groupID` = `usm`.`groupID`)))
        LEFT JOIN `userGroup` `usg` ON ((`usg`.`groupID` = `grp`.`groupID`)))
        LEFT JOIN `user` `usr` ON ((`usr`.`userID` = `usg`.`userID`)));

-- -----------------------------------------------------
-- View `simontok`.`vUserAccessLevel`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `simontok`.`vUserAccessLevel`;
USE `simontok`;
CREATE 
 OR REPLACE VIEW `vUserAccessLevel` AS
    SELECT 
        `usg`.`userID` AS `userID`,
        `usr`.`realName` AS `realname`,
        `usg`.`groupID` AS `groupID`,
        `grp`.`name` AS `name`,
        `pgr`.`pageID` AS `pageID`,
        `pgr`.`filename` AS `filename`,
        `ual`.`active` AS `active`
    FROM
        ((((`userGroup` `usg`
        LEFT JOIN `group` `grp` ON ((`grp`.`groupID` = `usg`.`groupID`)))
        LEFT JOIN `userAccessLevel` `ual` ON ((`ual`.`groupID` = `grp`.`groupID`)))
        LEFT JOIN `pageRegistered` `pgr` ON ((`pgr`.`pageID` = `ual`.`pageID`)))
        LEFT JOIN `user` `usr` ON ((`usr`.`userID` = `usg`.`userID`)))
    WHERE
        (`pgr`.`pageID` IS NOT NULL);

SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
